#
# Copyright 2015 Reverb Technologies, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
#
package WWW::SwaggerClient::StoreApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);


#use WWW::Swagger::Model::Category;
#use WWW::Swagger::Model::Pet;


use WWW::SwaggerClient::APIClient;

our @EXPORT_OK = qw(
  get_inventory 
  place_order 
  get_order_by_id 
  delete_order 
  
);

sub new {
    my $class   = shift;
    my $default_api_client = WWW::SwaggerClient::APIClient->new;
    my (%self) = (
        'api_client' => $default_api_client,
        @_
    );

    #my $self = {
    #    #api_client => $options->{api_client}
    #    api_client => $default_api_client
    #}; 

    bless \%self, $class;

}

    
    #
    # get_inventory
    #
    # Returns pet inventories by status
    # 
    # @return HASH[string,int]
    #
    sub get_inventory {
      my ($self, %args) = @_;

      

      # parse inputs
      my $_resource_path = '/store/inventory';
      $_resource_path =~ s/{format}/json/; # default format to json

      my $_method = 'GET';
      my $query_params = {};
      my $header_params = {};
      my $form_params = {};

      # 'Accept' and 'Content-Type' header
      my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
      if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
      }
      $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

      
      
      
      
      my $_body_data;
      

      # for HTTP post (form)
      #$_body_data = $_body ? undef : $form_params;

      # make the API Call
      my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                             $query_params, $form_params,
                                             $header_params, $_body_data);
      if (!$response) {
        return;
      }
  		my $_response_object = $self->{api_client}->deserialize('HASH[string,int]', $response);
  		return $_response_object;
      
  }
  
    #
    # place_order
    #
    # Place an order for a pet
    # 
    # @param Order $body order placed for purchasing the pet (required)
    # @return Order
    #
    sub place_order {
      my ($self, %args) = @_;

      

      # parse inputs
      my $_resource_path = '/store/order';
      $_resource_path =~ s/{format}/json/; # default format to json

      my $_method = 'POST';
      my $query_params = {};
      my $header_params = {};
      my $form_params = {};

      # 'Accept' and 'Content-Type' header
      my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
      if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
      }
      $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

      
      
      
      
      my $_body_data;
       # body params
      if ( exists $args{'body'}) {
        $_body_data = $args{'body'};
      }

      # for HTTP post (form)
      #$_body_data = $_body ? undef : $form_params;

      # make the API Call
      my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                             $query_params, $form_params,
                                             $header_params, $_body_data);
      if (!$response) {
        return;
      }
  		my $_response_object = $self->{api_client}->deserialize('Order', $response);
  		return $_response_object;
      
  }
  
    #
    # get_order_by_id
    #
    # Find purchase order by ID
    # 
    # @param string $order_id ID of pet that needs to be fetched (required)
    # @return Order
    #
    sub get_order_by_id {
      my ($self, %args) = @_;

      
      # verify the required parameter 'order_id' is set
      unless (exists $args{'order_id'}) {
        croak("Missing the required parameter 'order_id' when calling get_order_by_id");
      }
      

      # parse inputs
      my $_resource_path = '/store/order/{orderId}';
      $_resource_path =~ s/{format}/json/; # default format to json

      my $_method = 'GET';
      my $query_params = {};
      my $header_params = {};
      my $form_params = {};

      # 'Accept' and 'Content-Type' header
      my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
      if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
      }
      $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

      
      
       # path params
      if ( exists $args{'order_id'}) {
        my $_base_variable = "{" . "orderId" . "}";
        my $_base_value = WWW::SwaggerClient::APIClient::to_path_value($args{'order_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
      }
      
      my $_body_data;
      

      # for HTTP post (form)
      #$_body_data = $_body ? undef : $form_params;

      # make the API Call
      my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                             $query_params, $form_params,
                                             $header_params, $_body_data);
      if (!$response) {
        return;
      }
  		my $_response_object = $self->{api_client}->deserialize('Order', $response);
  		return $_response_object;
      
  }
  
    #
    # delete_order
    #
    # Delete purchase order by ID
    # 
    # @param string $order_id ID of the order that needs to be deleted (required)
    # @return void
    #
    sub delete_order {
      my ($self, %args) = @_;

      
      # verify the required parameter 'order_id' is set
      unless (exists $args{'order_id'}) {
        croak("Missing the required parameter 'order_id' when calling delete_order");
      }
      

      # parse inputs
      my $_resource_path = '/store/order/{orderId}';
      $_resource_path =~ s/{format}/json/; # default format to json

      my $_method = 'DELETE';
      my $query_params = {};
      my $header_params = {};
      my $form_params = {};

      # 'Accept' and 'Content-Type' header
      my $_header_accept = $self->{api_client}->select_header_accept('application/json', 'application/xml');
      if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
      }
      $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

      
      
       # path params
      if ( exists $args{'order_id'}) {
        my $_base_variable = "{" . "orderId" . "}";
        my $_base_value = WWW::SwaggerClient::APIClient::to_path_value($args{'order_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
      }
      
      my $_body_data;
      

      # for HTTP post (form)
      #$_body_data = $_body ? undef : $form_params;

      # make the API Call
      
      $self->{api_client}->call_api($_resource_path, $_method,
                                             $query_params, $form_params,
                                             $header_params, $_body_data);
      return;
      
  }
  


1;
